/* rygel-lms-artist.c generated by valac 0.44.9, the Vala compiler
 * generated from rygel-lms-artist.vala, do not modify */

/*
 * Copyright (C) 2013 Intel Corporation.
 *
 * Author: Jussi Kukkonen <jussi.kukkonen@intel.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <rygel-server.h>
#include <glib-object.h>
#include <sqlite3.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <rygel-db.h>

#define RYGEL_LMS_TYPE_CATEGORY_CONTAINER (rygel_lms_category_container_get_type ())
#define RYGEL_LMS_CATEGORY_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_LMS_TYPE_CATEGORY_CONTAINER, RygelLMSCategoryContainer))
#define RYGEL_LMS_CATEGORY_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_LMS_TYPE_CATEGORY_CONTAINER, RygelLMSCategoryContainerClass))
#define RYGEL_LMS_IS_CATEGORY_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_LMS_TYPE_CATEGORY_CONTAINER))
#define RYGEL_LMS_IS_CATEGORY_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_LMS_TYPE_CATEGORY_CONTAINER))
#define RYGEL_LMS_CATEGORY_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_LMS_TYPE_CATEGORY_CONTAINER, RygelLMSCategoryContainerClass))

typedef struct _RygelLMSCategoryContainer RygelLMSCategoryContainer;
typedef struct _RygelLMSCategoryContainerClass RygelLMSCategoryContainerClass;
typedef struct _RygelLMSCategoryContainerPrivate RygelLMSCategoryContainerPrivate;

#define RYGEL_LMS_TYPE_ARTIST (rygel_lms_artist_get_type ())
#define RYGEL_LMS_ARTIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_LMS_TYPE_ARTIST, RygelLMSArtist))
#define RYGEL_LMS_ARTIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_LMS_TYPE_ARTIST, RygelLMSArtistClass))
#define RYGEL_LMS_IS_ARTIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_LMS_TYPE_ARTIST))
#define RYGEL_LMS_IS_ARTIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_LMS_TYPE_ARTIST))
#define RYGEL_LMS_ARTIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_LMS_TYPE_ARTIST, RygelLMSArtistClass))

typedef struct _RygelLMSArtist RygelLMSArtist;
typedef struct _RygelLMSArtistClass RygelLMSArtistClass;
typedef struct _RygelLMSArtistPrivate RygelLMSArtistPrivate;
enum  {
	RYGEL_LMS_ARTIST_0_PROPERTY,
	RYGEL_LMS_ARTIST_NUM_PROPERTIES
};
static GParamSpec* rygel_lms_artist_properties[RYGEL_LMS_ARTIST_NUM_PROPERTIES];

#define RYGEL_LMS_TYPE_DATABASE (rygel_lms_database_get_type ())
#define RYGEL_LMS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_LMS_TYPE_DATABASE, RygelLMSDatabase))
#define RYGEL_LMS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_LMS_TYPE_DATABASE, RygelLMSDatabaseClass))
#define RYGEL_LMS_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_LMS_TYPE_DATABASE))
#define RYGEL_LMS_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_LMS_TYPE_DATABASE))
#define RYGEL_LMS_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_LMS_TYPE_DATABASE, RygelLMSDatabaseClass))

typedef struct _RygelLMSDatabase RygelLMSDatabase;
typedef struct _RygelLMSDatabaseClass RygelLMSDatabaseClass;

#define RYGEL_LMS_TYPE_ALBUM (rygel_lms_album_get_type ())
#define RYGEL_LMS_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_LMS_TYPE_ALBUM, RygelLMSAlbum))
#define RYGEL_LMS_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_LMS_TYPE_ALBUM, RygelLMSAlbumClass))
#define RYGEL_LMS_IS_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_LMS_TYPE_ALBUM))
#define RYGEL_LMS_IS_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_LMS_TYPE_ALBUM))
#define RYGEL_LMS_ALBUM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_LMS_TYPE_ALBUM, RygelLMSAlbumClass))

typedef struct _RygelLMSAlbum RygelLMSAlbum;
typedef struct _RygelLMSAlbumClass RygelLMSAlbumClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _RygelLMSCategoryContainer {
	RygelMediaContainer parent_instance;
	RygelLMSCategoryContainerPrivate * priv;
	RygelDatabaseCursor* cursor_all;
	RygelDatabaseCursor* cursor_find_object;
	RygelDatabaseCursor* cursor_added;
	RygelDatabaseCursor* cursor_removed;
	gchar* child_prefix;
	gchar* ref_prefix;
};

struct _RygelLMSCategoryContainerClass {
	RygelMediaContainerClass parent_class;
	RygelMediaObject* (*object_from_statement) (RygelLMSCategoryContainer* self, sqlite3_stmt* statement);
	gchar* (*get_sql_all_with_filter) (RygelLMSCategoryContainer* self, const gchar* filter);
	gchar* (*get_sql_count_with_filter) (RygelLMSCategoryContainer* self, const gchar* filter);
	guint (*get_child_count_with_filter) (RygelLMSCategoryContainer* self, const gchar* where_filter, GValueArray* args);
	RygelMediaObjects* (*get_children_with_filter) (RygelLMSCategoryContainer* self, const gchar* where_filter, GValueArray* args, const gchar* sort_criteria, guint offset, guint max_count);
};

struct _RygelLMSArtist {
	RygelLMSCategoryContainer parent_instance;
	RygelLMSArtistPrivate * priv;
};

struct _RygelLMSArtistClass {
	RygelLMSCategoryContainerClass parent_class;
};

static gpointer rygel_lms_artist_parent_class = NULL;

GType rygel_lms_category_container_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelLMSCategoryContainer, g_object_unref)
GType rygel_lms_artist_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelLMSArtist, g_object_unref)
#define RYGEL_LMS_ARTIST_SQL_ALL_TEMPLATE "SELECT audio_albums.id, audio_albums.name " "FROM audio_albums " "WHERE audio_albums.artist_id = %s " "LIMIT ? OFFSET ?;"
#define RYGEL_LMS_ARTIST_SQL_COUNT_TEMPLATE "SELECT COUNT(audio_albums.id) " "FROM audio_albums " "WHERE audio_albums.artist_id = %s"
#define RYGEL_LMS_ARTIST_SQL_FIND_OBJECT_TEMPLATE "SELECT audio_albums.id, audio_albums.name " "FROM audio_albums " "WHERE audio_albums.id = ? AND audio_albums.artist_id = %s;"
static gchar* rygel_lms_artist_get_sql_all (const gchar* id);
static gchar* rygel_lms_artist_get_sql_find_object (const gchar* id);
static gchar* rygel_lms_artist_get_sql_count (const gchar* id);
static RygelMediaObject* rygel_lms_artist_real_object_from_statement (RygelLMSCategoryContainer* base,
                                                               sqlite3_stmt* statement);
GType rygel_lms_database_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelLMSDatabase, g_object_unref)
RygelLMSDatabase* rygel_lms_category_container_get_lms_db (RygelLMSCategoryContainer* self);
RygelLMSAlbum* rygel_lms_album_new (const gchar* db_id,
                                    RygelMediaContainer* parent,
                                    const gchar* title,
                                    RygelLMSDatabase* lms_db);
RygelLMSAlbum* rygel_lms_album_construct (GType object_type,
                                          const gchar* db_id,
                                          RygelMediaContainer* parent,
                                          const gchar* title,
                                          RygelLMSDatabase* lms_db);
GType rygel_lms_album_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RygelLMSAlbum, g_object_unref)
RygelLMSArtist* rygel_lms_artist_new (const gchar* id,
                                      RygelMediaContainer* parent,
                                      const gchar* title,
                                      RygelLMSDatabase* lms_db);
RygelLMSArtist* rygel_lms_artist_construct (GType object_type,
                                            const gchar* id,
                                            RygelMediaContainer* parent,
                                            const gchar* title,
                                            RygelLMSDatabase* lms_db);
RygelLMSCategoryContainer* rygel_lms_category_container_construct (GType object_type,
                                                                   const gchar* db_id,
                                                                   RygelMediaContainer* parent,
                                                                   const gchar* title,
                                                                   RygelLMSDatabase* lms_db,
                                                                   const gchar* sql_all,
                                                                   const gchar* sql_find_object,
                                                                   const gchar* sql_count,
                                                                   const gchar* sql_added,
                                                                   const gchar* sql_removed);

static gchar*
rygel_lms_artist_get_sql_all (const gchar* id)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (id != NULL, NULL);
	_tmp0_ = g_strdup_printf (RYGEL_LMS_ARTIST_SQL_ALL_TEMPLATE, id);
	result = _tmp0_;
	return result;
}

static gchar*
rygel_lms_artist_get_sql_find_object (const gchar* id)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (id != NULL, NULL);
	_tmp0_ = g_strdup_printf (RYGEL_LMS_ARTIST_SQL_FIND_OBJECT_TEMPLATE, id);
	result = _tmp0_;
	return result;
}

static gchar*
rygel_lms_artist_get_sql_count (const gchar* id)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (id != NULL, NULL);
	_tmp0_ = g_strdup_printf (RYGEL_LMS_ARTIST_SQL_COUNT_TEMPLATE, id);
	result = _tmp0_;
	return result;
}

static RygelMediaObject*
rygel_lms_artist_real_object_from_statement (RygelLMSCategoryContainer* base,
                                             sqlite3_stmt* statement)
{
	RygelLMSArtist * self;
	gchar* db_id = NULL;
	gchar* _tmp0_;
	gchar* title = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	RygelLMSDatabase* _tmp3_;
	RygelLMSDatabase* _tmp4_;
	RygelLMSAlbum* _tmp5_;
	RygelMediaObject* result = NULL;
	self = (RygelLMSArtist*) base;
	g_return_val_if_fail (statement != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%d", sqlite3_column_int (statement, 0));
	db_id = _tmp0_;
	_tmp1_ = (const gchar*) sqlite3_column_text (statement, 1);
	_tmp2_ = g_strdup (_tmp1_);
	title = _tmp2_;
	_tmp3_ = rygel_lms_category_container_get_lms_db ((RygelLMSCategoryContainer*) self);
	_tmp4_ = _tmp3_;
	_tmp5_ = rygel_lms_album_new (db_id, (RygelMediaContainer*) self, title, _tmp4_);
	result = (RygelMediaObject*) _tmp5_;
	_g_free0 (title);
	_g_free0 (db_id);
	return result;
}

RygelLMSArtist*
rygel_lms_artist_construct (GType object_type,
                            const gchar* id,
                            RygelMediaContainer* parent,
                            const gchar* title,
                            RygelLMSDatabase* lms_db)
{
	RygelLMSArtist * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_val_if_fail (id != NULL, NULL);
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (lms_db != NULL, NULL);
	_tmp0_ = rygel_lms_artist_get_sql_all (id);
	_tmp1_ = _tmp0_;
	_tmp2_ = rygel_lms_artist_get_sql_find_object (id);
	_tmp3_ = _tmp2_;
	_tmp4_ = rygel_lms_artist_get_sql_count (id);
	_tmp5_ = _tmp4_;
	self = (RygelLMSArtist*) rygel_lms_category_container_construct (object_type, id, parent, title, lms_db, _tmp1_, _tmp3_, _tmp5_, NULL, NULL);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	return self;
}

RygelLMSArtist*
rygel_lms_artist_new (const gchar* id,
                      RygelMediaContainer* parent,
                      const gchar* title,
                      RygelLMSDatabase* lms_db)
{
	return rygel_lms_artist_construct (RYGEL_LMS_TYPE_ARTIST, id, parent, title, lms_db);
}

static void
rygel_lms_artist_class_init (RygelLMSArtistClass * klass,
                             gpointer klass_data)
{
	rygel_lms_artist_parent_class = g_type_class_peek_parent (klass);
	((RygelLMSCategoryContainerClass *) klass)->object_from_statement = (RygelMediaObject* (*) (RygelLMSCategoryContainer*, sqlite3_stmt*)) rygel_lms_artist_real_object_from_statement;
}

static void
rygel_lms_artist_instance_init (RygelLMSArtist * self,
                                gpointer klass)
{
}

GType
rygel_lms_artist_get_type (void)
{
	static volatile gsize rygel_lms_artist_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_lms_artist_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelLMSArtistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_lms_artist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelLMSArtist), 0, (GInstanceInitFunc) rygel_lms_artist_instance_init, NULL };
		GType rygel_lms_artist_type_id;
		rygel_lms_artist_type_id = g_type_register_static (RYGEL_LMS_TYPE_CATEGORY_CONTAINER, "RygelLMSArtist", &g_define_type_info, 0);
		g_once_init_leave (&rygel_lms_artist_type_id__volatile, rygel_lms_artist_type_id);
	}
	return rygel_lms_artist_type_id__volatile;
}

